//
// global.h: All EXCON globals.
//
// ------------------------------------------------
// Mumit Khan <khan@xraylith.wisc.edu>
// Center for X-ray Lithography
// University of Wisconsin-Madison
// 3731 Schneider Dr., Stoughton, WI, 53589
// ------------------------------------------------
//
// Copyright (c) 1991-1996 Mumit Khan
//
//

#ifndef excon_ui_global_h
#define excon_ui_global_h

#include "xrtypes.h"

// All global variables in excon.

/**************************************************************************/

extern class CleanupMgr* GLB_cleanupmgr;
extern class Stats* GLB_stats;
extern char* GLB_programname;	// NAME USED TO INVOKE THIS PROGRAM
extern class Pmu* GLB_pmu;
extern class ExpMgr* GLB_expmgr;
extern class ToolsMgr* GLB_toolsmgr;
extern class JobMgr* GLB_jobmgr;
extern class Logger* GLB_logger;
extern class Stq* GLB_file_search_path;

extern bool GLB_debug;	// TURN ON DEBUGGING INFO
extern bool GLB_resdebug;	// DEBUG RESOLVE STEPS
extern bool GLB_repdebug;	// DEBUG REPORT CONSTRUCTION
extern bool GLB_rundebug;	// DEBUG EXPERIMENT EXECUTION
extern bool GLB_coldebug;	// DEBUG REPORT COLLECTION

/**************************************************************************/

#endif/*excon_ui_global_h*/
