$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!
$! Make trace files of SHADOW.
$!
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$
$ say :== write sys$output
$
$ say " "
$ say "# Building the TRACE Modules of SHADOW/VMS #"
$ say " "
$
$!
$! Define the symbols necessary for compilation.
$!
$
$! set on
$! on error then goto CLEANUP
$! on control_c then goto CLEANUP
$! on control_y then goto CLEANUP
$
$ on error then continue
$ on warning then continue
$ on severe then continue
$
$
$!
$! Define the compilation flags. These flags are actually reset in
$! COMPILE.COM, so watch out.
$!
$
$ defines 	:=
$ ccompile 	:= cc'defines'/undefine=(ANSI_LIB)/debug/nooptimize
$ fcompile 	:= fortran'defines'/debug/nooptimize
$ compile	:= @[-]compile.com
$
$!
$! The libraries that are created here, and that are used in linking.
$!
$
$ libname 	= "libtrace.olb"
$ libshadow	= "[-.lib]libshadow"
$ libspg 	= "[-.tools.spg]libspg.olb"
$
$!
$! Go thru all subdirectories (if any) first and make those.
$!
$
$!
$! Compile all the source files.
$!
$
$!
$! create the local library first if it doesn't exist yet.
$!
$
$ if f$search(libname) .eqs. "" 
$ then 
$	say "Creating library ''libname'"
$	library/create 'libname'
$ endif
$ say " "
$
$ compile crystal.for
$ compile diffrac.for
$ compile funny.for
$ compile image.for
$ compile imref.for
$ compile input_oe.for
$ compile intercept.for
$ compile koma1.for
$ compile koma2.for
$ compile kumakhov.for
$ compile mirror.for
$ compile mosaic.for
$ compile msetup.for
$ compile optaxis.for
$ compile pspect.for
$ compile reflec.for
$ compile reset.for
$ compile restart.for
$ compile rotit.for
$ compile rotsour.for 
$ compile screen.for
$ compile segment.for
$ compile setsour.for
$ compile sur_spline.for
$ compile surface.for
$ compile switchinp.for
$ compile trace_step.for 
$
$ compile trace.for
$ compile shadowit.for
$
$ say " "
$ say "Adding *.obj to library ''libname'"
$ say " "
$ lib/replace 'libname' 	-
	crystal,	-
	diffrac,	-
	funny,		-
	image,		-
	imref,		-
	input_oe,	-
	intercept,	-
	koma1,		-
	koma2,		-
	kumakhov,	-
	mirror,		-	
	mosaic,		-
	msetup,		-	
	optaxis,	-	
	pspect,		-	
	reflec,		-	
	reset,		-
	restart,	-	
	rotit,		-
	rotsour,	-
	screen,		-
	segment,	-
	setsour,	-
	sur_spline,	-
	surface,	-
	switchinp,	-
	trace_step
$!
$! Make the final programs in this directory.
$!
$
$
$!
$! Define the libraries needed to link these programs here.
$!
$
$ libraries 	= "'libname'/lib, 'libshadow'/lib, 'libspg'/lib"
$
$ say "Linking... trace"
$ link trace, 'libraries'
$ say "Linking... shadowit"
$ link shadowit, 'libraries'
$
$ CLEANUP:
$ say " "
$ say "# Done Making the TRACE Modules of SHADOW/VMS #"
$ say " "
$
