	program menu_prog
	implicit integer (a-z)
#if defined(unix) || HAVE_F77_CPP
#       include "parms.inc"
#       include "menu.inc"
#       include "nl1data.inc"
#       include "nldata.inc"
#elif defined(vms)
	include 'parms.inc'
	include 'menu.inc'
	include 'nl1data.inc'
	include 'nldata.inc'
#endif
c
	character*3 selrec
	data selrec /'SRC'/
	character*1 yesno
c
	character*(l_menuname) menu
c
#ifndef vms
	character*132	menufname
	logical lexist
#endif
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c  Initialize CRT logic and arm control/c intercept
c
	call tt_init
c
c  activates ^E switch
c
	call	monitorenable (1)
c
c  turn off scroll logic
c
	call scroll (0)
c
c  initial call to controlc 'arms' control/c intercept logic
c  this routine should be called after each control/c to rearm intercept 
c
	call controlc (iflag)
c
c  load synonyms/menu definitions/command definitions
c     and values for variables which are always defined 
c       (these are chiefly command menu options and have
c	(little to do with optical elements/screens/sources)
c
c  let menu program use fortran units 1 and 2
c
#ifdef vms
	call menu_init (1,2,'menudata')
#else
c
c  first check for environment override, and if that fails, use the 
c  SHADOW_DATA_DIR env variable or hard-coded menu filename passed during 
c  build time via Makefile. This is usually $(SHADOW_DATA_DIR)/shadow.men.
c
	call getenv ("SHADOW_MENU_FILE", menufname)
	if (menufname(1:1) .eq. ' ') then
C
C Get the data file path using either SHADOW$DATA or Unix SHADOW_DATA_DIR
C environment variable. Also, check for existence in the routine itself.
C
	  iflag = 1
	  call datapath ('shadow.men', menufname, IFLAG)
	  if (iflag.ne.0) then
	    lexist = .false.
	  else
	    lexist = .true.
	  endif
	else
	    inquire (file = menufname, exist = lexist)
	endif
	if (.not.lexist) then
	    call mssg('MENU','Cannot access menu file shadow.men', -1)
	    message = 'Fatal Error'
	    call user_message
	    call curses_exit_subroutine
	    call exit (1)
	endif
        call menu_init (1,2,menufname)
#endif
c
c  set current optical element and screen
c
	call cur_set (1,1)
c
c  create default source
c
	call addSource
c
c  invoke main routine
c
d     	IWHAT = IYES ('Test record ? ')
d     	IF (IWHAT.EQ.1) GOTO 11
 10	call doit
c
c  test anytime for the user entering control/C using the followining method
c  to continue to intercept control/c you must call this routine each time
c  the user types control/c in order to 'rearm' the control/c intercept logic
c
	call controlc (iflag)
#ifdef vms
	if (iflag .ne. 0) write (6,111)
 111	format (' Control/C received')
#else
	if (iflag .ne. 0) write (message,111)
	call simpleMessage
 111	format (' Control/C received')
#endif
c
c  This call resets the scroll region to full screen
c  A non-zero argument sets the top line of the scroll region
c    this only works on terminals that support partial screen scrolling
c    such as the VT100 (but not VT52)
c
	call scroll (0)
c
c  This  call flushes any output created by the terminal independent
c    library routines.  The buffering provides good performance improvements
c    but require that you flush the buffer to the terminal before doing any
c    input.  Failure to do this will mean that the user will have to
c    supply answers to questions before the prompts have been seeing the
c    prompts !
c
	call flush_buffer
#ifndef vms
	call curses_exit_subroutine
#endif
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c  print out list
c
d	go to 11
	goto 9999
c
c bypass debug code
c
d 11     write (6,101) 'Record to display [Example: OE SCR SRC] '
d 101	format (1x,$,a)
d	read (5,102,end=9999) selrec
d 102	format (a)
d	call upcase (selrec)
d	if (selrec .eq. ' ') goto 10
d	start=0
d 100	call nl_find (start,selrec,' ',-1,-1)
d	if (start .eq. 0) goto 190
d	  write (6,1010) nl_name,nl_own1,nl_own2,nl_datatype,
d     *			nl_int,nl_real,nl_string
d 1010	  format (1x,a,1x,'(',i2,',',i2,')',3x,a,1x,i10,1x,g10.3,
d     *		1x,'"',a,'"')
d	goto 100
d
d 190	write (6,1005)
d 1005	format (///' End of list')
d	goto 10
 9999	call exit (0)
	end
